-- RezzTextMonitor by Archivar of Lothar
-- todo: Versions check. 

----------------------------------------------------------------------------------
-- Hier wird das Addon initalisiert							  					--
----------------------------------------------------------------------------------
function RTM_OnLoad()
	RTMRezzer = {}																	-- Variablen fr Monitor
	RTMSettings = {}																-- Variable fr die Optionen
	RTMDebug = {}																	-- Nur fr Debug Zwecke
	RTM_RegEvents()																	-- Events registrieren
	SLASH_REZZTM1 = "/rtm";															-- Slashkommando Einrichten
	SlashCmdList["REZZTM"] = RTM_slash;												-- Slashkommando Einrichten
end
---------------------------------------------------------------------------------
function RTM_Debug(text)															-- Chatausgabe, nur zur Fehlersuche
	if (vcomsave) and  (vcomsave["debuga"] == "on") then							-- Variable aus meinem Hauptinterface
		DEFAULT_CHAT_FRAME:AddMessage(text ,0,1,1);									-- Ja, ok dann Chatausgabe
	end
end
----------------------------------------------------------------------------------
-- Wird der Slasbefehl /rtm ausgefhrt, wird hier das Optionsfenster geffnet	--
----------------------------------------------------------------------------------
function RTM_slash()
	RezzTextMonitorOptions_Toggle()													-- Optionsfenster ffnen
end
----------------------------------------------------------------------------------
-- Nachdem die AddonVariablen geladen worden sind, gehts hier weiter			--
----------------------------------------------------------------------------------
function RTM_VARIABLES_LOADED()
	if not RTMSettings.Scale then RTMSettings.Scale = 1 ; end ;						-- Skalierung vom monitorfenster
	if not RTMSettings.RText then RTMSettings.RText = "auto" ; end ;				-- Monitorfenster Anzeigen an/aus/auto
	if not RTMSettings.ChatText then RTMSettings.ChatText = "on" ; end ;			-- Chattext an/aus
	if not RTMSettings.noBattleText then RTMSettings.noBattleText = "off" ; end ;	-- Chattext Battleground an/aus
	if not RTMSettings.noBattleMoni then RTMSettings.noBattleMoni = "off" ; end ;	-- Chattext Battleground an/aus
	if not RTMSettings.Lock then RTMSettings.Lock = "off" ; end ;					-- Monitorfenster Fixierung an/aus
	if not RTMSettings.Time then RTMSettings.Time = "off" ; end ;					-- Monitor Zeitgeber
	if not RTMSettings.Macro then RTMSettings.Macro = "off" ; end ;					-- RezzMacro creator
	if not RTMSettings.CustomText then RTMSettings.CustomText = RTM_REZZTEXT ; end ;-- custom WIederbelebungstext
	if not RTMSettings.TextChannel then RTMSettings.TextChannel = "auto" ; end ;	-- Channel fr Textausgabe auto/raid/say/group
	getglobal("TitelZeile_Text"):SetText(RTM_MONITORLABEL);							-- berschrift des MonitorFensters setzen
	RezzMonitorFenster:SetHeight(25);												-- Hhe des Monitorfensters
	RezzMonitorFenster:SetScale(RTMSettings.Scale);									-- Jo, na dann mal gre vom Monitor ndern
	RezzTextMonitorOptionsRezzBox:SetText(RTMSettings.CustomText);					-- berschrift im Optionsfenster setzen
	if (IsAddOnLoaded("RezzText")) then												-- Die beiden Addons laufen nicht zusammen !!!
		DisableAddOn("RezzText")													-- Also eines der Addons ausschalten :)
		StaticPopup_Show ("reload-ui-RT");											-- Popup Fenster zeigen (ReloadUI ja/nein)
	end	
	RTM_SetRangeSpell()																-- RezzSpruch und dessen Reichweite suchen
	RTM_MonitorDisplay()															-- Fenster initalisieren
	if (vcomsave) and (vcomsave["chatfilter"] == "on") then							-- Chatfilteroption vom Vcom an ?
		-- Nix machen																-- Keine Chatausgabe!
	else																			-- OK, Kein Chatfilter
		DEFAULT_CHAT_FRAME:AddMessage(RTM_LOADED,1,1,0);							-- Willkommensnachricht ausgeben
	end

	local oldFunc = GameTooltip:GetScript("OnShow");								-- GameTooltip wird hier abgefangen.
	if ( oldFunc ) then 															-- Fals es schon ein Funktion gibt, wird sie gehooked
	   GameTooltip:SetScript("OnShow", function() oldFunc(); RTM_GameTooltip_OnShow(); end );
	else
	   GameTooltip:SetScript("OnShow", RTM_GameTooltip_OnShow);						-- Ok gibt nix, also selber anlegen
	end

end
----------------------------------------------------------------------------------
-- Sobald ein Tooltip erscheint wird nach "Leiche von " gesucht; 				--
----------------------------------------------------------------------------------
function RTM_GameTooltip_OnShow()
	local textleft = getglobal("GameTooltipTextLeft1"):GetText();					-- Linken TooltipText auslesen
	if (textleft) then																-- Gibts Text ?
		if string.find(textleft,RTM_TOOLCORPSE) then 								-- Leichnam von gefunden
			RTMCorpseName = string.gsub(textleft, RTM_TOOLCORPSE, "")				-- Versuche Namen auszulesen & zu speichern
		end
	end
end
----------------------------------------------------------------------------------
-- Hier ist die DialogBox, die aufgerufen wird, wenn RezzText gefunden wird		--
----------------------------------------------------------------------------------
StaticPopupDialogs["reload-ui-RT"] = {												-- Name der Box "reload-ui-RT"
  text = RTM_SPDTEXT,																-- Der Text. steht in den Language dateien
  button1 = RTM_SPDJA,																-- Der Ja Button
  button2 = RTM_SPDNEIN,															-- Der nein oder abbruch Button
  OnAccept = function()																-- Sollte auf "JA" gedrckt werden..
      ReloadUI();																	-- wird hier die UI neu gelden
  end,
  timeout = 0,																		-- Kein Timeout
  whileDead = 1,																	-- whileDead
  hideOnEscape = 1																	-- mit [ESC] schlieen
}
----------------------------------------------------------------------------------
-- Hier werden die events registriert die wir fr das addon brauchen			--
----------------------------------------------------------------------------------
function RTM_RegEvents()															-- Event Registrierung
	this:RegisterEvent("UNIT_SPELLCAST_SENT");										-- Zauber gestartet (nur Player)
	this:RegisterEvent("UNIT_SPELLCAST_FAILED");									-- Zauber Abgebrochen ?
	this:RegisterEvent("UNIT_SPELLCAST_START");										-- Zauber gestartet (alle im raid AUCH player)
	this:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");									-- Zauber erfolgreich
	this:RegisterEvent("UNIT_SPELLCAST_STOP");										-- Zauber gestoppt
	this:RegisterEvent("PLAYER_TARGET_CHANGED");									-- Ziel gewechselt 
	this:RegisterEvent("CHAT_MSG_ADDON");											-- AddonSyncChannel
	this:RegisterEvent("VARIABLES_LOADED");											-- Variablen vom Addon geladen.
	this:RegisterEvent("PLAYER_REGEN_ENABLED");										-- Spieler regeneriert (kann trinken)
	this:RegisterEvent("PLAYER_REGEN_DISABLED");									-- Spieler ist im Kampf
end
----------------------------------------------------------------------------------
-- Hier werden Zauber ausgewertet (wird aus der RezzTextMonitor.xml aufgerufen)	--
-- arg1 = "player", arg2 = "Heilen", arg3 = "Rang 1", arg4 = "Zielname"			--
----------------------------------------------------------------------------------
function RTM_SPELLCAST_SENT(RTMUnit,arg2,arg3,RTMZielName)
	RTMRezzZielName = RTM_UNKNOWN													-- Name auf Unbekannt setzen
	if RezzSpell(arg2) and RTMUnit == "player" then									-- Daten fr mich ? 
		if (not RTMZielName) or (RTMZielName == "") then 							-- Haben ICH kein richtiges Target ?
			local textleft = getglobal("GameTooltipTextLeft1"):GetText();			-- Egal, lesen wir den linken TooltipText aus
			if (textleft) then														-- Gibts Text ? (oder Tooltip schon zu)
				RTMZielName = string.gsub(textleft, RTM_TOOLCORPSE, "")				-- Versuche Namen auszulesen
			end
			if (not RTMZielName) or (RTMZielName == "") then						-- Immer noch keinen Zielnamen ?
				RTMZielName = RTM_UNKNOWN											-- dann, "Ziel unbekannt"
			end
		end
		RTMRezzZielName = RTMZielName												-- Name hier speichern fr Spellcast_START
	end
end
----------------------------------------------------------------------------------
-- Dieses Event wird ausgefhrt, wenn ein Spell wirklich gecastet wird			--
----------------------------------------------------------------------------------
function RTM_SPELLCAST_START(RTMUnit)
	local spell, _, _, _, _, _ = UnitCastingInfo(RTMUnit); 							-- Daten fr den Zauber auslesen
	if RTMUnit == "player" then														-- Info ber mich selber "player"?
		if RezzSpell(spell) then 													-- Wird ein Wiederbelebungsspruch gestartet ?
			if ((RTMRezzZielName == RTM_UNKNOWN) or (not RTMRezzZielName)) and (RTMCorpseName) then
				RTMRezzZielName = RTMCorpseName										-- Name in letzter Sekunde noch tauschen :)
			end
			RTM_PRINT(RTMRezzZielName)												-- Wiederbelebungstext ausgeben
			TransferData = "[["..UnitName(RTMUnit).."]] [["..spell.."]] [["..RTMRezzZielName.."]] [[START]]"		
			SendAddonMessage( "RTM", TransferData, "RAID" );						-- Syncen
			RTM_RezzStart(UnitName(RTMUnit),spell,RTMRezzZielName,"SyncUnit")		-- Start in Tabelle eintragen
			RTMCorpseName = nil														-- Nach einem Rezz lschen
		end
	end
	if UnitName(RTMUnit) == UnitName("player") then									-- Info ber mich selber ?
		return																		-- Nix machen, wenn wir keinen wiederbeleben
	end
	if (string.sub(RTMUnit,1,4) ~= "raid") and (string.sub(RTMUnit,1,4) ~= "party") then -- Kommen die Daten aus Gruppe oder Raid ?
		return																		-- Nein, also brechen wir hier ab.
	end
	local Target = UnitName(RTMUnit.."target")										-- Ziel ist das Ziel des Zieles. ja ja ^^
	if (Target) and (not ZielTot(Target)) then 										-- Ziel ist nicht Tot ? 
		Target = RTM_UNKNOWN														-- dann, "Ziel unbekannt"
	end
	if (not Target) or (Target == "") then											-- keinen Zielnamen ?
		Target = RTM_UNKNOWN														-- dann, "Ziel unbekannt"
	end
	RTM_RezzStart(UnitName(RTMUnit),spell,Target,"Start")							-- Caster Spell und Ziel in Liste bernehmen
end
----------------------------------------------------------------------------------
-- Dieses Event wird ausgefhrt, wenn ein Spell fehlgeschlagen ist				--
----------------------------------------------------------------------------------
function RTM_SPELLCAST_FAILED(RTMUnit)
	if RTMUnit == "player" then														-- Info ber mich selber "player"?
		TransferData = "[["..UnitName(RTMUnit).."]] [[nix]] [[nix]] [[FAILED]]"		
		SendAddonMessage( "RTM", TransferData, "RAID" );							-- Syncen
	end
	RTM_RezzFehlgeschlagen(UnitName(RTMUnit))										-- kein LOS ? , mu also fehlschlagen
end
----------------------------------------------------------------------------------
function RTM_SPELLCAST_SUCCEEDED(RTMUnit,Spell,Rank)
	if RezzSpell(Spell) then 														-- Wiederbelebungsspruch erfolgreich ?
		RTM_RezzGelungen(UnitName(RTMUnit))											-- Name war beim Rezzen erfolgreich
		TransferData = "[["..UnitName(RTMUnit).."]] [[nix]] [[nix]] [[SUCCEEDED]]"		
		SendAddonMessage( "RTM", TransferData, "RAID" );							-- Syncen
	else																			-- Kein Wiederbelebungsspruch ?
		RTM_RezzFehlgeschlagen(UnitName(RTMUnit))									-- Kein RezzSpruch, mu also fehlschlagen
	end
end
----------------------------------------------------------------------------------
function RTM_SPELLCAST_STOP(RTMUnit)
	if RTMUnit == "player" then														-- Bin ich selber der Zauberer ?
		TransferData = "[["..UnitName(RTMUnit).."]] [[nix]] [[nix]] [[STOP]]"		
		SendAddonMessage( "RTM", TransferData, "RAID" );							-- Syncen
	end
	RTM_RezzStop(UnitName(RTMUnit))													-- Caster aus liste lschen
end
----------------------------------------------------------------------------------
function RTM_TARGET_CHANGED()
	RTM_MonitorDisplay()															-- RezzMonitor Anzeigen
end
----------------------------------------------------------------------------------
-- Hier werden die Addon Sync Nachrichten ausgewertet							--
----------------------------------------------------------------------------------
function RTM_MSG_ADDON(AddonID,TransferData,Zielgruppe,sender)
	if AddonID == "RTM" then 														-- Daten aus unserem Addon ? 
		local Name = nil															-- Variable Name lschen
		local Spell = nil															-- Variable Spell lschen
		local Target = nil															-- Variable Target lschen
		local Aktion = nil															-- Variable Aktion lschen
		-- Hier versuchen wir die variablen aus dem addon String zu lesen		
		for arg1, arg2, arg3, arg4 in string.gmatch(TransferData, "%[%[([^%s]+)%]%] %[%[([^%s]+)%]%] %[%[([^%s]+)%]%] %[%[([^%s]+)%]%]") do
			Name = arg1																-- Name aus TransferData auslesen
			Spell = arg2															-- Spell aus TransferData auslesen
			Target = arg3															-- Target aus TransferData auslesen
			Aktion = arg4															-- Aktion aus TransferData auslesen
		end
		if sender == UnitName("player") then										-- Sende ich mir selber Syncdaten ?
			if (Name) and (Spell) and (Target) and (Aktion) then
				-- Nix machen														-- Alle 4 Werte erkannt. alles Prima
			else
				RTMDebug[TransferData] = "Player - corrupt selfsync!"				-- MKB Sync Fehlerhaft. DEBUGGEN
			end
			return																	-- Ok, kennich schon. abbrechen.
		end
		if (Name) and (Spell) and (Target) and (Aktion) then						-- Prima, Daten von der Neuen Version
			if Aktion == "SUCCEEDED" then
--				RTM_Debug("[RTM_MSG_ADDON] SUCCEEDED!"..Name)
				RTM_RezzGelungen(Name)												-- Name war beim Rezzen erfolgreich
			elseif Aktion == "START" then
--				RTM_Debug("[RTM_MSG_ADDON] START!"..Name)
				RTM_RezzStart(Name,Spell,Target,"SyncUnit")							-- wiederbelebung gestartet
			elseif Aktion == "FAILED" then
--				RTM_Debug("[RTM_MSG_ADDON] FAILED!"..Name)
				RTM_RezzFehlgeschlagen(Name)										-- Zauber fehlgeschlagen
			elseif Aktion == "STOP" then
--				RTM_Debug("[RTM_MSG_ADDON] STOP!"..Name)
				RTM_RezzStop(Name)													-- Zauber fehlgeschlagen
			elseif Aktion == "VER" then												-- Versionsabfrage ?
				RTM_Debug("[RTM_MSG_ADDON] VER!"..Name)						
				TransferData = "[["..UnitName("player").."]] [["..GetAddOnMetadata("RezzTextMonitor", "Version").."]] [["..sender.."]] [[INFO]]"		
				SendAddonMessage( "RTM", TransferData, "RAID" )
			elseif Aktion == "INFO" then											-- Versionsabfrage ?
--				RTM_Debug("[RTM_MSG_ADDON] INFO for "..Target)						
				RTM_Debug("[RTM_MSG_ADDON] INFO "..Name.." v"..Spell)						
			end
		else																		-- Daten aus der Alten Version. 
			-- alte daten, alte version
			if TransferData ~= RTM_UNKNOWN then 									-- Ist das Ziel bekannt ?
				if string.find(TransferData, "%[%[") then 							-- Daten korrupt ?
					RTMDebug[TransferData] = "Corrupt Sync!"
					-- Nix machen
				else
					RTMDebug[TransferData] = "Old Sync!"							-- MKB Debuggen, alter Sync
					RTM_RezzStart(sender,RTM_REZZSPELLS[1],TransferData,"Start")	-- Wiederbelebung gestartet
				end
			else
				RTM_RezzStop(sender)												-- Cast nicht auswertbar, also lschen.
			end
		end
	end
end
----------------------------------------------------------------------------------
function RTM_ROSTER_UPDATE()
	for k, v in pairs(RTMRezzer) do													-- Tabelle Durchsuchen mit Rezzern / Zielen
		if (ZielTot(RTMRezzer[k][4])) then											-- Ist das Ziel Tot, und kann in liste bleiben ?
			local SpellTime = GetTime()-RTMRezzer[k][3]								-- Zeit vergleichen, wie lange schon im Monitor.
			if SpellTime > 60 then													-- Nach 60 sekunden verschwindet das Rezzfenster
				RTMRezzer[k] = nil													-- Namen lschen. Der ist afk..
			elseif SpellTime > 10.5 then											-- Rezzen dauert lnger als 10.5 sek = lag
				if RTMRezzer[k][1] ~= RTM_REZZED then 								-- nicht schon einer der gerezzed wurde ?
					RTMRezzer["zzzrezz"..k] = {}									-- Neue Tabelle Anlegen
					RTMRezzer["zzzrezz"..k][1] = RTM_REZZED							-- alles mit Wiederbelebt markieren
					RTMRezzer["zzzrezz"..k][2] = RTMRezzer[k][2]
					RTMRezzer["zzzrezz"..k][3] = GetTime()
					RTMRezzer["zzzrezz"..k][4] = RTMRezzer[k][4]
					RTMRezzer["zzzrezz"..k][5] = ""
					RTMRezzer[k] = nil	
				end			
			end
		else
			RTMRezzer[k] = nil														-- Ziel nicht tot, Namen lschen.
		end
	end	
	RTM_MonitorDisplay()															-- Einziges Monitorupdate, mu alle 0.1 sek erfolgen
end
----------------------------------------------------------------------------------
-- Hier wird ein Name zur Liste hinzugefgt, und im Monitor angezeigt			--
----------------------------------------------------------------------------------
function RTM_RezzStart(Name,Spell,Target,Aktion)
	if (not RTMRezzer[Name]) then													-- Variable mit dem namen noch nicht dimensioniert ?
		RTMRezzer[Name] = {}														-- Also neu dimensionieren
	end
	if (RezzSpell(Spell) and (Target ~= RTM_UNKNOWN)) then 							-- Wird gerade ein Wiederbelebungsspruch ausgefhrt ?
		if Aktion == "SyncUnit" then												-- Ok das sind Sichere Daten, die werden geschrieben
			RTMRezzer[Name] = {Name, Aktion, GetTime(), Target}						-- Ja, also Name, Target etc speichern
		else																		-- Nein, nicht Sync, normale Daten
			if (RTMRezzer[Name][2]) and 
			(RTMRezzer[Name][2]) == "SyncUnit" then									-- Schon gesyncte Daten Vorhanden ?
				-- Nix machen														-- Ja, dann Nix machen
			else																	-- Nein, Daten mssen geschrieben werden
				RTMRezzer[Name] = {Name, Aktion, GetTime(), Target}					-- Daten (ber)schreiben
			end
		end
	else																			-- Nein, Kein Wiederbelebungsspruch
		RTMRezzer[Name] = nil														-- Dann Namen lschen.
	end
	-- MKB ist das Update hier ntig ?
	RTM_MonitorDisplay()															-- RezzMonitor Anzeigen
end

----------------------------------------------------------------------------------
function RTM_RezzGelungen(Name)
	for k, v in pairs(RTMRezzer) do													-- Tabelle Durchsuchen mit Rezzern / Zielen
		if RTMRezzer[k][1] == Name then												-- Caster gefunden, der gerade fertig wurde ?
			RTMRezzer["zzzrezz"..k] = {}											-- OK, dann eintrag "wiederbelebt" machen
			RTMRezzer["zzzrezz"..k][1] = RTM_REZZED									-- Text "Widerbelebt" in die Tabelle eintragen
			RTMRezzer["zzzrezz"..k][2] = RTMRezzer[k][2]							-- Aktion. (Start,Syncunit)
			RTMRezzer["zzzrezz"..k][3] = GetTime()									-- Zeit eintragen
			RTMRezzer["zzzrezz"..k][4] = RTMRezzer[k][4]							-- Das Ziel, das gerezzt wurde
			RTMRezzer["zzzrezz"..k][5] = ""
			RTMRezzer[k] = nil														-- Alte Tabelle lschen. 
		end
	end	
end
----------------------------------------------------------------------------------
function RTM_RezzFehlgeschlagen(Name)
	for k, v in pairs(RTMRezzer) do													-- Tabelle Durchsuchen mit Rezzern / Zielen
		if RTMRezzer[k][1] == Name then												-- Caster gefunden, der gerade abgebrochen hat ?
			RTMRezzer[k] = nil														-- Tabelle lschen. 
		end
	end	
end
----------------------------------------------------------------------------------
function RTM_RezzStop(Name)
	for k, v in pairs(RTMRezzer) do													-- Tabelle Durchsuchen mit Rezzern / Zielen
		if RTMRezzer[k][1] == Name then												-- Caster gefunden, der gerade abgebrochen hat ?
			local SpellTime = GetTime()-RTMRezzer[k][3]								-- Wie lange luft der Cast schon ?
			if SpellTime > 9.5 then													-- luft zauber schon ber 9.5 sekunden ?
				RTM_RezzGelungen(Name)												-- => 9.5 Sekunden, dann ist der rezz gelungen
			else
				RTM_RezzFehlgeschlagen(Name)										-- <= 9.5 Sekunden, der wurde abgebrochen.
			end
		end
	end	
end
----------------------------------------------------------------------------------
-- Hier wird geschaut, ob DAs ziel Tot ist. Oder Totgestellt, Jger zb ^^		--
----------------------------------------------------------------------------------
function ZielTot(RTMZielName)
	if (UnitName("Player") == RTMZielName) and (UnitIsDeadOrGhost("Player")) then	-- Spieler Tot ?
		return true																	-- Berichten wir true.
	end
	if GetNumRaidMembers() >=1 then													-- Befinden wir uns in einem Raid ?
	  	for i = 1, GetNumRaidMembers(), 1 do										-- Alle Raidmember durchsuchen
			local name, _, _, _, _, _, _, online, isDead = GetRaidRosterInfo(i);	-- Name und isDead auslesen
			if (isDead) and (online) and (name == RTMZielName) then					-- RaidMember online & ToT & unser Ziel ?
				return true															-- Berichten wir true.
			end
			if(UnitIsDeadOrGhost("Raid"..i)) and (online) and (not Totgestellt("Raid"..i)) and UnitName("Raid"..i) == RTMZielName then	-- Leiche verlassen ?
				return true															-- Berichten wir true.
			end
		end
	elseif GetNumPartyMembers() >=1 then											-- Befinden wir uns in einer Gruppe ?
	  	for i = 1, GetNumPartyMembers(), 1 do										-- Alle Partymember durchsuchen
			if(UnitIsDeadOrGhost("Party"..i)) and (UnitIsConnected("Party"..i)) and (not Totgestellt("Party"..i)) and (UnitName("Party"..i) == RTMZielName) then	-- Leiche verlassen ?
				return true															-- Berichten wir true.
			end
		end
	end
	return nil																		-- scheint noch zu leben der Spieler oder offline!
end
----------------------------------------------------------------------------------
function AnyOneDead()
	if GetNumRaidMembers() >=1 then													-- Befinden wir uns in einem Raid ?
	  	for i = 1, GetNumRaidMembers(), 1 do										-- Alle Raidmember durchsuchen
			local name, _, _, _, _, _, _, online, isDead = GetRaidRosterInfo(i);	-- isDead auslesen
			if (isDead)	and (online) then											-- RaidMember Tot und online ?
				return true															-- ok, es ist jemand tot
			end
			if(UnitIsDeadOrGhost("Raid"..i)) and (online) and (not Totgestellt("Raid"..i)) then	-- Ist der Spieler Geist oder tot ?
				return true															-- ok, doch Mausetot
			end
		end
	elseif GetNumPartyMembers() >=1 then											-- Befinden wir uns in einer Gruppe ?
	  	for i = 1, GetNumPartyMembers(), 1 do										-- Alle Partymember durchsuchen
			if(UnitIsDeadOrGhost("Party"..i)) and (UnitIsConnected("Party"..i)) and (not Totgestellt("Party"..i)) then	-- Leiche verlassen ?
				return true															-- Berichten wir true.
			end
		end
	end
	return nil
end
----------------------------------------------------------------------------------
-- Hier wird geprft, ob eines der BG's aktiv ist								--
----------------------------------------------------------------------------------
function RTM_InBG()
	if (MAX_BATTLEFIELD_QUEUES) then												-- Gibt es eine Warteschlange ?
		local status, mapName, instanceID, minlevel, maxlevel, teamSize;			-- Variablen vorbereiten
		for i=1, MAX_BATTLEFIELD_QUEUES do											-- Warteschlange abarbeiten
			status, mapName, instanceID, minlevel, maxlevel, teamSize = GetBattlefieldStatus(i);
			if( status == "active" ) then											-- Ein BG in der Warteschlange aktiv ?
				return true															-- Ok, dann sind wir im BG
			end
		end
	end
	return nil																		-- Nix Aktic, also sind wir nicht im BG
end
----------------------------------------------------------------------------------
-- Hier wird geprft, ob der Char Wiederbeleben kann							--
----------------------------------------------------------------------------------
function RTM_IsRezzer()
	local UC = UnitClass("player")													-- In UC speichern, welche Classer der Char angehrt
	if 	UC == RTM_PRIEST or UC == RTM_PALADIN or UC == RTM_SHAMAN or UC == RTM_DRUID then
		return true																	-- true ! Klasse ist Priest, Pala, Schami oder Dudu
	else
		return nil																	-- nil ! Klasse kann nicht Rezzen
	end
end
----------------------------------------------------------------------------------
-- Hier wird das RezzMonitor Fenster angezeigt									--
----------------------------------------------------------------------------------
function RTM_MonitorDisplay()
	if (RTMSettings.noBattleMoni == "on") and (RTM_InBG()) then						-- Bin Ich im Battleground ?
		HideUIPanel(RezzMonitorFenster);											-- Ja, also Monitor schlieen
		return																		-- Und zurck
	end
	if RTMSettings["RText"] == "on" then											-- Option, Monitor immer an ?
		-- Nix machen, alles bestens :)
	elseif RTMSettings["RText"] == "off" then										-- Option, Monitor immer aus ?
		HideUIPanel(RezzMonitorFenster);											-- ok, Fenster ausmachen
		return																		-- und wieder weg hier ^^
	else																			-- Automatik ! ja ja und ich mu hier schuften...
		if (RTM_STOP) then															-- wir sind im Kampf, also eh aus
			HideUIPanel(RezzMonitorFenster);										-- ok, Fenster ausmachen
			return																	-- und zurck
		else
			if (not AnyOneDead()) then												-- Keiner  ToT ?
				HideUIPanel(RezzMonitorFenster);									-- ok, Fenster ausmachen
				return																-- Dann kann ich auch net rezzen. zurck ! 
			end
			if (not RTM_IsRezzer()) then											-- Bin ich kein Rezzer ?
				HideUIPanel(RezzMonitorFenster);									-- ok, Fenster ausmachen
				return																-- Dann kann ich auch net rezzen. zurck ! 
			end				
		end			
	end
	----------------------------------------------------------------------------------
	-- MonitorTabelle wird nach doppelten eintrgen durchsucht						--
	----------------------------------------------------------------------------------
	local k, v, k2, v2
	for k, v in pairs(RTMRezzer) do														-- Tabelle Durchsuchen mit Rezzern / Zielen
		for k2, v2 in pairs(RTMRezzer) do												-- Tabelle Durchsuchen mit Rezzern / Zielen
			if k ~= k2 then																-- Haben wir uns etwas selbst gefunden ? 
				if 	RTMRezzer[k][4] == RTMRezzer[k2][4]	and								-- Doppelten eintrag gefunden ?
				RTMRezzer[k][1] == RTM_REZZED and
				RTMRezzer[k2][1] == RTM_REZZED then	
					if 	RTMRezzer[k][3] > RTMRezzer[k2][3]	then						-- Zeitvergleich, kleiner wird gelscht
						RTMRezzer[k2][4] = "deletebitte"
						RTMRezzer[k2][1] = "deletebitte"
						break
					else
						RTMRezzer[k][4] = "deletebitte"
						RTMRezzer[k][1] = "deletebitte"
						break
					end
				end
			end
		end
	end
	----------------------------------------------------------------------------------
	-- Hier werden alle zum lschen markierte eintrge entfernt.					--
	-- Wer sich wundert, warum erst die Eintrge markiert werden, und dann erst		--
	-- gelscht werden: Versucht mal 2 Tabellen doppelt verschachtelt zu			--
	-- durchsuchen, und gleichzeitig Elemente der Tabelle zu lschen..genau, die	--
	-- Tabellen werden jedesmal neu angeordnet und das kostet Zeit. mehr Zeit als	--
	-- spter alles in einem rutsch zu lschen :) 									--
	----------------------------------------------------------------------------------
	for k, v in pairs(RTMRezzer) do														-- So, nochmal die ganzen Namen durchgehen
		if RTMRezzer[k][1] == "deletebitte" then										-- alles was zum lschen markiert wurde...
			RTMRezzer[k] = nil															-- ... oh wunder, wird gelscht ^^
		end	
	end
	----------------------------------------------------------------------------------
	-- Hier wird die Tabelle der Toten in einem Array zum sortieren					--
	-- ersteinmal zwischengespeichert, und dann sortiert							--
	----------------------------------------------------------------------------------
	local RTMSORT = {}																-- Array zum Sortieren dimensionieren
    for n in pairs(RTMRezzer) do table.insert(RTMSORT, n) end						-- Arrays wiederum in eine Tabbele legen
    table.sort(RTMSORT)																-- Tabelle jetzt sortieren
	local z = 0
    for i,k in ipairs(RTMSORT) do
		z=z+1																		-- Wir Zhlen die Zeilen hier mit
		if z >=16 then																-- Mehr als 15 Rezzer ? oops, abbruch :)
			break																	-- Einfach zurck springen
		end
		local Name = RTMRezzer[k][1]												-- Name aus der Tabelle Auslesen
		local RTMUnit = RTMRezzer[k][2]
		local SpellTime = floor( GetTime()-RTMRezzer[k][3])	
		local Target = RTMRezzer[k][4]

		ShowFarbe = "|cff00FF00"													-- Standartfarbe grn
		if Name == RTM_REZZED then													-- Ziel schon wiederbelebt ?
			ShowFarbe = "|cffD0D0E0"												-- Hellgrau, wiederbelebt und noch nicht angenommen.
		end
		if (UnitName("player") == Name) then 										-- Mein Name in Tabelle ?
			ShowFarbe = "|cff4040FF"												-- Farbe Blau, ich bins
		end
		if (UnitName("player") == Name) and (UnitName("target")) == Target then 	-- Mein Name und mein Target in Tabelle ?
			ShowFarbe = "|cff1010FF"												-- Farbe DunkelBlau, Mein Target
		end
		if (UnitName("player") ~= Name) and (UnitName("target")) == Target then 	-- Nicht Mein Name und Neim Target in Tabelle ?
			ShowFarbe = "|cffFF0000"												-- Farbe ROT, Doppeltes Target
		end
		if string.len(Name) >= 14 then												-- Name lnger als 14 Buchstaben ?
			Name = string.sub(Name,1,14).."..."										-- Ja, dann krzen und "..." anhngen
		end
		if string.len(Target) >= 14 then											-- TargetName lnger als 14 Buchstaben ?
			Target = string.sub(Target,1,14).."..."									-- Ja, dann krzen und "..." anhngen
		end

		getglobal("LinksZeile"..z.."_Text"):SetText(ShowFarbe..Name);				-- Linke Zeile mit Zaubernden setzen
		if RTMSettings.Time == "on" then											-- Sekundenanzeiga an ?
			getglobal("RechtsZeile"..z.."_Text"):SetText(ShowFarbe..Target.." {"..SpellTime.."}");-- Rechte Zeile mit Target (toter)
		else
			getglobal("RechtsZeile"..z.."_Text"):SetText(ShowFarbe..Target);		-- Rechte Zeile mit Target (toter)
		end
		getglobal("LinksZeile"..z):Show();											-- linke Zeile Anzeigen lassen
		getglobal("RechtsZeile"..z):Show();											-- rechte Zeile Anzeigen lassen
	end
	RezzMonitorFenster:SetHeight(25+z*10);											-- Neue Hhe vom RezMonitorFenster bestimmen
	for line=z+1,15 do																-- Wir Zhlen die Tabelle zu ende,
		getglobal("LinksZeile"..line):Hide();										-- und verstecken die linke und rechte Textzeile
		getglobal("RechtsZeile"..line):Hide();										-- weil sie leer sind :)
	end
	ShowUIPanel(RezzMonitorFenster);
end
----------------------------------------------------------------------------------
-- Hier wird geprft ob ein Wiederbelebungsspruch gezaubert wird				--
----------------------------------------------------------------------------------
function RezzSpell(Spell)
	for k, v in ipairs(RTM_REZZSPELLS) do											-- Liste der Wiederbelebungszauber abarbeiten
		if (v == Spell) then														-- Wird jetzt Wiederbelebungszauber gecastet ?
			return true																-- Ja, es wird wiederbelebt. true zurckgeben
		end
	end
	return nil																		-- Nein, kein Wiederbeleben. dann Nil ! (nix)
end
----------------------------------------------------------------------------------
-- Hier wird der Name des Ziels gesucht, und der Text gedruckt 					--
----------------------------------------------------------------------------------
function RTM_PRINT(arg4)
	if (not arg4) or (arg4 == RTM_UNKNOWN) then										-- Kein, oder Unbekanntes Ziel ?
		RTMDebug["function RTM_PRINT"] = "Name nil or unknown."						-- MKB Debuging
		return																		-- da gibts nix zu drucken.
	end
	if RTMSettings["ChatText"] ~= "on"	then										-- Chattext Ausgeschaltet ?
		return																		-- Ja, dann zurck
	end
	if RTMSettings.noBattleText == "on" and (RTM_InBG()) then						-- Bin Ich im Battleground ?
		return																		-- Ja, dann zurck und keinen Text drucken
	end
	if (arg4) and (arg4 ~= "") then													-- Haben wir einen Namen gespeichert ?
    	local text = string.gsub(RTMSettings.CustomText, "<name>", arg4)			-- Platzhalter <name> gegen richtigen Namen tauschen
		if RTMSettings["TextChannel"] == "auto" then								-- Auto funktion an ?
			if GetNumRaidMembers() >=1 then											-- Befinden wir uns in einem Raid ?
				SendChatMessage(text, "RAID", Common)								-- Ja, also text in den Raidchat.
			elseif GetNumPartyMembers() >=1 then									-- Befinden wir uns in einer Gruppe ?
				SendChatMessage(text, "PARTY", Common)								-- Ja, also text in den Gruppenchat.
			else																	-- keine Gruppe, kein Raid. was bleibt da...
				SendChatMessage(text, "SAY", Common)								-- Genau: der SAY Chat.
			end
		elseif RTMSettings["TextChannel"] == "say" then
			SendChatMessage(text, "SAY", Common)									-- SAY Chat.
		elseif RTMSettings["TextChannel"] == "group" then
			SendChatMessage(text, "PARTY", Common)									-- Gruppenchat.
		elseif RTMSettings["TextChannel"] == "raid" then
			SendChatMessage(text, "RAID", Common)									-- Raidchat.
		end
	end
end
----------------------------------------------------------------------------------
-- Hier wird das Event zur regeneration abgefragt								--
----------------------------------------------------------------------------------
function RTM_REGEN(arg)
	if (arg) then 
		RTM_STOP = nil																-- Regeneration. wir knnten rezzen. alles an !
	else
		RTM_STOP = true																-- Kampf, Also arbeit stoppen
	end
	RTM_MonitorDisplay()															-- Monitor updaten
end
----------------------------------------------------------------------------------
-- Hier kommt ein update Event an. und das so 1000 mal pro sekunde				--
----------------------------------------------------------------------------------
function RTM_OnUpdate(arg1)
	if (not RT_Timer) then RT_Timer = 0 ; end ;										-- Variable setzen, falls nicht vorhanden
	RT_Timer = RT_Timer + arg1														-- Zeit hochzhlen
	if RT_Timer >= 0.1 then															-- ist eine Sekunde vergangen ?
		RT_Timer = 0																-- Ja eine Sekunde ist vergangen, 
		RTM_ROSTER_UPDATE()															-- dann updaten wir jetzt die Leute im Monitor
		RTM_Makro()																	-- Und das Makro wir auch jetzt erstellt
	else																			-- Weniger als 1 sekunde vergangen
		return																		-- STOP, nix machen.
	end
end
----------------------------------------------------------------------------------
-- berpffen, ob sich das ziel totgestellt hat									--
----------------------------------------------------------------------------------
function Totgestellt(RTMUnit)
	local VBuffwegName;																-- Variable zum speichern vorbereiten
	for i=0,16,1 do																	-- Alle 16 Buffs prfen
		local bidx = UnitBuff(RTMUnit,i)											-- Buff auslesen
		if (bidx) and (bidx ~= -1) then												-- Gibs berhaupt buffs auf dem Ziel ?
			RTMTooltip:SetOwner(UIParent, "ANCHOR_NONE");							-- Eigenens Tooltipfenster an UI binden
			RTMTooltip:SetUnitBuff(RTMUnit,i)										-- Buff in Tooltip laden
			VBuffwegName = RTMTooltipTextLeft1:GetText()							-- Tetx aus dem Tooltip auslesen
			RTMTooltip:Hide();														-- Tooltip verstecken
			if (VBuffwegName) and (VBuffwegName == RTM_FEIGNDEATH) then  			-- Totstellen buff gefuenden ?
				return true															-- Ja, also true zurckgeben
			end
		end
	end
	return nil																		-- nix gefunden, fehlschlag nil !
end
----------------------------------------------------------------------------------
-- Hier werden Tote Ziele in Reichweite Gesucht, um ein RezzMacro zu erstellen	--
----------------------------------------------------------------------------------
function RTM_Makro()
	if (RTM_STOP) then																-- Wir sind am Kmpfen
		if (RTM_MakroCreated) then													-- Ja. Gibt es schon ein macro ?
			RTM_MakroCreated = nil													-- Ja. Ok, Marker lschen
			RTM_MakroDEL()															-- Und Rezzmacro lschen
		end	
		return																		-- Also nix machen 
	end
	if RTMSettings.Macro ~= "on" then												-- Macro Generierung an ?
		return																		-- Nein, also zurck
	end
	if (ZielTot(UnitName("player"))) then											-- bin ich selber tot ?
		return																		-- Ja, dann brauchich kein macro. zurck !
	end
	if (not RTM_IsRezzer()) then													-- Bin ich kein Rezzer ?
		return																		-- Dann kann ich auch net rezzen. zurck ! 
	end				
	NrACCMacros, NrCHAMacros = GetNumMacros();
	if NrCHAMacros > 18 then														-- Mehr als 18 macros. Stop !
		return																		-- Ja, dann machen wir nix.
	end
	if (not AnyOneDead()) then														-- Leben alle im Raid ?
		if (RTM_MakroCreated) then													-- Ja. Gibt es schon ein macro ?
			RTM_MakroCreated = nil													-- Ja. Ok, Marker lschen
			RTM_MakroDEL()															-- Und Rezzmacro lschen
		end	
		return																		-- Da alle Leben, brauchen wir auch kein Makro!
	end
	----------------------------------------------------------------------------------
	-- Alle die tot sind werden hier in eine Tabelle geschrieben					--
	----------------------------------------------------------------------------------
	RTM_Tote = {}																	-- Tabelle der Toten lschen
	if GetNumRaidMembers() >=1 then													-- Befinden wir uns in einem Raid ?
	  	for i = 1, GetNumRaidMembers(), 1 do										-- Alle Raidmember durchsuchen
			local name, _, _, _, _, _, _, online, isDead = GetRaidRosterInfo(i);	-- isDead auslesen
			if (isDead)	and (online) then											-- RaidMember Tot und online ?
				RTM_Tote[name] = NameToUnit(name)									-- Name in Totenliste Eintagen
			end
			if(UnitIsDeadOrGhost("Raid"..i)) and (online) and (not Totgestellt("Raid"..i)) then	-- Ist der Spieler Geist oder tot ?
				RTM_Tote[UnitName("Raid"..i)] = "raid"..i							-- Name in Totenliste Eintagen
			end
		end
	elseif GetNumPartyMembers() >=1 then											-- Befinden wir uns in einer Gruppe ?
	  	for i = 1, GetNumPartyMembers(), 1 do										-- Alle Partymember durchsuchen
			if(UnitIsDeadOrGhost("Party"..i)) and (UnitIsConnected("Party"..i)) and (not Totgestellt("Party"..i)) then	-- Leiche verlassen ?
				RTM_Tote[UnitName("Party"..i)] = "Party"..i							-- Name in Totenliste Eintagen
			end
		end
	end
	----------------------------------------------------------------------------------
	-- Alle die nicht in Reichweite sind, aussortieren								--
	----------------------------------------------------------------------------------
	if (not RTMRezzZauber) or (RTMRezzZauber == "") then							-- Haben wir Zauber fr Reichweitenkennung ?
		RTM_SetRangeSpell()															-- Nein ? OK, dann bitte nacholen
	end	
	for k, v in pairs(RTM_Tote) do													-- Liste der Toten abarbeiten
		local InReichweite = IsSpellInRange(RTMRezzZauber,v)						-- Ist der Tote in Reichweite ?
		if InReichweite and InReichweite == 1 then									-- Ja, Toter ist in Reichweite. nix machen
			-- Nix machen
		else																		-- Nein, Toter ist nicht in Reichweite
			RTM_Tote[k] = nil														-- nicht in Reichweite also lschen
		end
	end
	----------------------------------------------------------------------------------
	-- Alle die schon im RezzMonitor als Ziel stehen auch raus						--
	----------------------------------------------------------------------------------
	local k, v, k2, v2
	for k, v in pairs(RTMRezzer) do													-- Tabelle Durchsuchen mit Rezzern / Zielen
		local Target = RTMRezzer[k][4]												-- Momentanen Caster Auswhlen
		for k2, v2 in pairs(RTM_Tote) do											-- Liste der Totendurchsuchen
			if k2 == Target then													-- Toter wird schon wiederbelebt
				RTM_Tote[k2] = nil													-- Toten aus Liste lschen.
			end				
		end
	end
	----------------------------------------------------------------------------------
	-- Hier Angekommen haben wir eine Liste mit Toten, die in Reichweite liegen,	--
	-- und noch nicht von anderen gerezzt werden. 									--
	----------------------------------------------------------------------------------
	local RezzMeUnit = nil															-- RezzMeUnit wird am Ende wiederbelebt
	for k, v in pairs(RTM_Tote) do													-- Liste aller toten durchgehen
		RezzMeUnit = RTM_Tote[k]													-- ok, Ab hier haben wir einen Toten zum Rezzen
	end
	----------------------------------------------------------------------------------
	-- Sollten wir einen Druide in der Gruppe haben, dann wird der vorgezogen. 		--
	----------------------------------------------------------------------------------
	for k, v in pairs(RTM_Tote) do													-- Liste der Toten abarbeiten
		if UnitClass(RTM_Tote[k]) == RTM_DRUID then 								-- Druide gefunden.
			RezzMeUnit = RTM_Tote[k]												-- Neues Rezz Ziel. ein Druide !
		end		
	end
	----------------------------------------------------------------------------------
	-- Sollten wir einen Schamane in der Gruppe haben, dann wird der vorgezogen. 	--
	----------------------------------------------------------------------------------
	for k, v in pairs(RTM_Tote) do													-- Liste der Toten abarbeiten
		if UnitClass(RTM_Tote[k]) == RTM_SHAMAN then 								-- Schamane gefunden.
			RezzMeUnit = RTM_Tote[k]												-- Neues Rezz Ziel. ein Schamane !
		end		
	end
	----------------------------------------------------------------------------------
	-- Sollten wir einen Paladin in der Gruppe haben, dann wird der vorgezogen. 	--
	----------------------------------------------------------------------------------
	for k, v in pairs(RTM_Tote) do													-- Liste der Toten abarbeiten
		if UnitClass(RTM_Tote[k]) == RTM_PALADIN then 								-- Paladin gefunden.
			RezzMeUnit = RTM_Tote[k]												-- Neues Rezz Ziel. ein Paladin !
		end		
	end
	----------------------------------------------------------------------------------
	-- Sollten wir einen Priester in der Gruppe haben, dann wird der vorgezogen. 	--
	----------------------------------------------------------------------------------
	for k, v in pairs(RTM_Tote) do													-- Liste der Toten abarbeiten
		if UnitClass(RTM_Tote[k]) == RTM_PRIEST then 								-- Priester gefunden.
			RezzMeUnit = RTM_Tote[k]												-- Neues Rezz Ziel. ein Priester !
		end		
	end
	----------------------------------------------------------------------------------
	-- Ab hier haben wir die Unit eines Toten in RezzMeUnit gespeichert.			--
	-- Erst Priester, dann Paladin, Schamane, Druide. na und dann den Rest :)		--
	----------------------------------------------------------------------------------
	if (RezzMeUnit) then															-- Zur Sicherheit fragen ob es eine Unit gibt
		RezzMeName = string.sub(UnitName(RezzMeUnit),1,string.len(UnitName(RezzMeUnit))-1)-- Letzten Buchstaben vom Namen abschneiden :)
	else																			-- Ok, keine Unit gefunden, also nix rezzen
		RezzMeName = nil
	end
	----------------------------------------------------------------------------------
	-- Da wir den Namen haben, knnen wir jetzt das Makro zusammenstellen			--
	----------------------------------------------------------------------------------
	if (RezzMeName) then															-- Kausalittsabfrage: Existiert RezzMeUnit ?
		RTM_MakroCreated = true														-- Zwischenspeichern, das wir Makro machen
		local MACRO_NAME = "RTM"													-- Der Name des Makros
		local MACRO_BILD = 1														-- Die Nummer des Bildes fr das Makro
		if (LAST_MACRO_BILD) then													-- Hier wird zwischen 2 Bilder gewechselt
			MACRO_BILD = 1															-- damit es schn blinkt :)
			LAST_MACRO_BILD = nil
		else
			MACRO_BILD = 471
			LAST_MACRO_BILD = 471
		end
		local MACRO_BODY = 			   "/target "..UnitName(RezzMeUnit).."\n" 		-- Der Text, der ins Makro geschreiben wird
		local MACRO_BODY = MACRO_BODY.."/wirken "..RTMRezzZauber.."\n"				-- Erst Zielen, dann wiederbeleben
		RTMmakro(MACRO_NAME,MACRO_BODY,MACRO_BILD)									-- Und Das Makro erstellen
	else																			-- Keinen zum Wiederbeleben gefunden ?
		if (RTM_MakroCreated) then													-- OKI, dann lschen wir das RezzMakro
			RTM_MakroCreated = nil
			RTM_MakroDEL()
		end	
	end
end
----------------------------------------------------------------------------------
-- Hier wird das Makro erstellt. entweder ein Neues, oder das alte erschreiben --
----------------------------------------------------------------------------------
function RTMmakro(MACRO_NAME,MACRO_BODY,MACRO_BILD)
	local MAX_MACROS = 18															-- Maximal 18 Makros erlaubt
	local numACCMacros, numCHARMacros = GetNumMacros();								-- Globale und Charakter Makros (Anzahl)
	local macroname = nil;
	local id = nil;
	for i = MAX_MACROS, MAX_MACROS + numCHARMacros do								-- Alle Makros durchsuchen
		macroname = GetMacroInfo(i);												-- Makroname Auslesen
		if (macroname == MACRO_NAME) then											-- Name, gleich unserem Makronamen ?
			id = i;																	-- Ja, dann ID merken
			break;																	-- und Schleife verlassen, wir sind fertig
		end
	end
	if (macroname and id) then														-- Existieren makroname und ID ?
		EditMacro(id, MACRO_NAME, MACRO_BILD, MACRO_BODY, 1);						-- Ja, also altes Makro berschreiben
	else
		CreateMacro(MACRO_NAME, MACRO_BILD, MACRO_BODY, 1, true);					-- Nein, dann machen wir eben ein Neues Makro
	end
end
----------------------------------------------------------------------------------
-- Hier wird ein leeres Makro erstellt, falls niemand da ist zum rezzen, und der--
-- SPieler trotzdem das Makro drckt. warum auch immer ^^						--
----------------------------------------------------------------------------------
function RTM_MakroDEL()
	NrACCMacros, NrCHAMacros = GetNumMacros();
	if NrCHAMacros >= 19 then														-- Mehr als 18 macros. Stop !
		return
	end
	local MACRO_NAME = "RTM"														-- Name des Makros
	local MACRO_BILD = 209															-- Die Nummer des Bildes frs Makro
	local MACRO_BODY = "-- RezzTextMonitor Macro -- \n"								-- Makrotext
	RTMmakro(MACRO_NAME,MACRO_BODY,MACRO_BILD)										-- Makro erstellen
end
----------------------------------------------------------------------------------
-- Hier wird zu einem Spielernamen die Unit gesucht. zB Archivar -> Raid7		--
----------------------------------------------------------------------------------
function NameToUnit(RTMNameTU)
	if GetNumRaidMembers() >=1 then													-- Befinden wir uns in einem Raid ?
		for i=1, GetNumRaidMembers() do												-- Jedes Raidmitglied durchgehen
			if (UnitName("raid"..i) == RTMNameTU) then								-- Name in Raid gefunden ?
				return "raid"..i													-- Und Abbrechen. job erledigt
			end
		end
	elseif GetNumPartyMembers() >=1 then											-- Befinden wir uns in einer Gruppe ?
		for i=1, GetNumPartyMembers() do											-- Jedes Raidmitglied durchgehen
			if (UnitName("party"..i) == RTMNameTU) then								-- Name in Raid gefunden ?
				return "party"..i													-- Und Abbrechen. job erledigt
			end
		end
	elseif UnitName("player") == RTMNameTU then										-- keine Gruppe, kein Raid. was bleibt da...
		return "player"																-- Falls nix gefunden wird, player zurck geben
	else
		RTMDebug["NameToUnit:"..RTMNameTU] = "Can't find the Unit for this name!"	-- MKB Debug
	end
end
----------------------------------------------------------------------------------
-- Hier wird nach dem Zauberspruch gesucht, der zum wiederbeleben benutzt wird.	--
----------------------------------------------------------------------------------
function RTM_SetRangeSpell()
	RTMRezzZauber = ""																-- Variable fr den Wiederbelebungszauber lschen
	local i = 1																		-- Lokalen Zhler bei 1 starten
	while (true) do
		local spellname, spellRank = GetSpellName(i, BOOKTYPE_SPELL);				-- Zauber aus Buch auslesen
		if (not spellname) then														-- Kein Zauber ? dann zurck 
			return
		end
		for k, v in ipairs(RTM_REZZSPELLS) do										-- Liste der Wiederbelebungszauber abarbeiten
			if (v == spellname) then												-- Wird jetzt Wiederbelebungszauber gecastet ?
				RTMRezzZauber = spellname											-- Wiederbelebungszauber zwischenspeichern
				return 																-- Ja, es wird wiederbelebt. true zurckgeben
			end
		end
		i = i + 1																	-- Zhler + 1. Also nchsten Zauber scannen
	end
end
----------------------------------------------------------------------------------
--  --
----------------------------------------------------------------------------------

