
function RezzTextMonitorOptions_OnLoad()
	RezzTextMonitorOptionsScaleSlider:SetMinMaxValues(0.5, 1.5);
	RezzTextMonitorOptionsScaleSlider:SetValueStep(0.01);
	RezzTextMonitorOptionsScaleSliderLow:SetText("0.5");
	RezzTextMonitorOptionsScaleSliderHigh:SetText("1.5");
end


function RezzTextMonitorOptions_OnShow()
	RezzTextMonitorOptionsScaleSlider:SetValue(RTMSettings.Scale);
	RTextCheckButton_ONLOAD()
	RezzTextMonitorOptionsChatButton_ONLOAD()
	RezzTextMonitorOptionsBattleButton_ONLOAD()
	RezzTextMonitorOptionsLockButton_ONLOAD()
	RezzTextMonitorOptionsTimeButton_ONLOAD()
	RezzTextMonitorOptionsMacroButton_ONLOAD()
	RezzTextMonitorOptionsACButton_ONLOAD()
	RezzTextMonitorOptionsRTextBattleCheckButton_ONLOAD()
end
function RezzTextMonitorOptions_Toggle()
	if RezzTextMonitorOptions:IsVisible() then
		RezzTextMonitorOptionsFrameOff()
	else
		RezzTextMonitorOptionsFrameOn()
	end
end

function RezzTextMonitorOptionsFrameOn()
	ShowUIPanel(RezzTextMonitorOptions);
end
function RezzTextMonitorOptionsFrameOff()
	HideUIPanel(RezzTextMonitorOptions);
end

function RezzTextMonitorOptionsScaleSlider_OnValueChanged()
	RTMSettings.Scale = this:GetValue();
	RezzTextMonitorOptionsScaleSliderText:SetText(RTM_OMSCALE.."  " .. format("%.2f", RTMSettings.Scale));
	RezzMonitorFenster:SetScale(RTMSettings.Scale);
	ShowUIPanel(RezzMonitorFenster);
end

function RezzTextMonitorOptionsOkButton_OnClick()
	RezzTextMonitorOptionsFrameOff()
end

function RezzTextMonitorOptionsResetButton_OnClick()
	RTMSettings.CustomText = RTM_REZZTEXT
	RezzTextMonitorOptionsRezzBox:SetText(RTMSettings.CustomText);
end

function RezzTextMonitorOptions_Toogle(befehl,Variable)
	if string.find(befehl, "on") then												-- Parameter "on" gefunden ?
		RTMSettings[Variable] = "on"									-- Ja, dann Variable auf "on" setzen
	elseif string.find(befehl, "off") then											-- Parameter "off" gefunden ?
		RTMSettings[Variable] = "off"									-- Ja, dann Variable auf "off" setzen
	elseif string.find(befehl, "auto") then											-- Parameter "off" gefunden ?
		RTMSettings[Variable] = "auto"									-- Ja, dann Variable auf "off" setzen
	else																			-- Parameter "Toogle" oder nix gefunden ?
		if RTMSettings[Variable] == "on" then							-- Ok, falls Variable "on" ist..
			RTMSettings[Variable] = "off"								-- dann Variable auf "off" setzen
		elseif	RTMSettings[Variable] == "off" then						-- Ok, falls Variable "off" ist..
			RTMSettings[Variable] = "auto"								-- dann wird sie jetzt auf "auto" gesetzt
		else																		-- Variable war "auto"...
			RTMSettings[Variable] = "on"								-- dann wird sie jetzt auf "on" gesetzt
		end
	end
end
function RTextCheckButton_ONLOAD()
	if RTMSettings["RText"] == "on" then
		RezzTextMonitorOptionsRTextOnCheckButton:SetChecked(1);
		RezzTextMonitorOptionsRTextOffCheckButton:SetChecked(0);
		RezzTextMonitorOptionsRTextautoCheckButton:SetChecked(0);
	elseif RTMSettings["RText"] == "off" then
		RezzTextMonitorOptionsRTextOnCheckButton:SetChecked(0);
		RezzTextMonitorOptionsRTextOffCheckButton:SetChecked(1);
		RezzTextMonitorOptionsRTextautoCheckButton:SetChecked(0);
	else
		RezzTextMonitorOptionsRTextOnCheckButton:SetChecked(0);
		RezzTextMonitorOptionsRTextOffCheckButton:SetChecked(0);
		RezzTextMonitorOptionsRTextautoCheckButton:SetChecked(1);
	end
	RTM_MonitorDisplay()
end
function RezzTextMonitorOptionsChatButton_ONLOAD()
	if RTMSettings["ChatText"] == "on" then
		RezzTextMonitorOptionsChatButton:SetChecked(1);
	else
		RezzTextMonitorOptionsChatButton:SetChecked(0);
	end
end
function RezzTextMonitorOptionsBattleButton_ONLOAD()
	if RTMSettings["noBattleText"] == "on" then
		RezzTextMonitorOptionsBattleButton:SetChecked(1);
	else
		RezzTextMonitorOptionsBattleButton:SetChecked(0);
	end
end
function RezzTextMonitorOptionsRTextBattleCheckButton_ONLOAD()
	if RTMSettings["noBattleMoni"] == "on" then
		RezzTextMonitorOptionsRTextBattleCheckButton:SetChecked(1);
	else
		RezzTextMonitorOptionsRTextBattleCheckButton:SetChecked(0);
	end
end
function RezzTextMonitorOptionsLockButton_ONLOAD()
	if RTMSettings["Lock"] == "on" then
		RezzTextMonitorOptionsLockButton:SetChecked(1);
	else
		RezzTextMonitorOptionsLockButton:SetChecked(0);
	end
end
function RezzTextMonitorOptionsTimeButton_ONLOAD()
	if RTMSettings["Time"] == "on" then
		RezzTextMonitorOptionsTimeButton:SetChecked(1);
	else
		RezzTextMonitorOptionsTimeButton:SetChecked(0);
	end
end
function RezzTextMonitorOptionsMacroButton_ONLOAD()
	if RTMSettings["Macro"] == "on" then
		RezzTextMonitorOptionsMacroButton:SetChecked(1);
	else
		RezzTextMonitorOptionsMacroButton:SetChecked(0);
	end
end
function RezzTextMonitorOptionsACButton_ONLOAD()
	if RTMSettings.TextChannel == "auto" then
		RezzTextMonitorOptionsACButton:SetChecked(1);
		RezzTextMonitorOptionsSCButton:SetChecked(0);
		RezzTextMonitorOptionsGCButton:SetChecked(0);
		RezzTextMonitorOptionsRCButton:SetChecked(0);
	elseif RTMSettings.TextChannel == "say" then
		RezzTextMonitorOptionsACButton:SetChecked(0);
		RezzTextMonitorOptionsSCButton:SetChecked(1);
		RezzTextMonitorOptionsGCButton:SetChecked(0);
		RezzTextMonitorOptionsRCButton:SetChecked(0);
	elseif RTMSettings.TextChannel == "group" then
		RezzTextMonitorOptionsACButton:SetChecked(0);
		RezzTextMonitorOptionsSCButton:SetChecked(0);
		RezzTextMonitorOptionsGCButton:SetChecked(1);
		RezzTextMonitorOptionsRCButton:SetChecked(0);
	elseif RTMSettings.TextChannel == "raid" then
		RezzTextMonitorOptionsACButton:SetChecked(0);
		RezzTextMonitorOptionsSCButton:SetChecked(0);
		RezzTextMonitorOptionsGCButton:SetChecked(0);
		RezzTextMonitorOptionsRCButton:SetChecked(1);
	end
end

function RezzTextMonitorOptionsRezzBox_OnTextChanged()
	RTMSettings.CustomText = RezzTextMonitorOptionsRezzBox:GetText()
end

function RTM_Tool_OnEnter(Knopf)
	if (not IsControlKeyDown()) then return; end ;

	local name = this:GetName()
	if (not name) then return; end;
   	name = string.gsub(name, "RezzTextMonitorOptions", "")							-- 
	RTM_Debug("[RTM_Tool_OnEnter] "..name)
	local text1 = RTMTooltips[name][1];
	local text2 = RTMTooltips[name][2];
	local text3 = RTMTooltips[name][3];

	RTM_Debug("[RTM_Tool_OnEnter] text1="..text1)
	RTM_Debug("[RTM_Tool_OnEnter] text2="..text2)
	RTM_Debug("[RTM_Tool_OnEnter] text3="..text3)


	RTMTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	RTMTooltip:SetPoint("BOTTOMRIGHT", this:GetName(), "TOPLEFT", 1, 1);
	RTMTooltip:ClearLines();
	RTMTooltip:AddLine(text1, .9,1,1);
	RTMTooltip:AddLine(text2, .1,.9,.1);
	RTMTooltip:AddLine(text3, .1,.9,.1);
	RTMTooltip:Show();
end

function RTM_Tool_OnLeave()
	RTMTooltip:Hide();
end

