-------------------------------------------------------------------------------
-- German localization
-------------------------------------------------------------------------------
if ( GetLocale() == "deDE" ) then

	BINDING_HEADER_REZZTEXTMONITOR_HEADER 	= "RezzTextMonitor"
	BINDING_NAME_OPTIONS					= "Optionen";
	BINDING_NAME_MONITOR					= "Wiederbelebungs Monitor";
	BINDING_NAME_LOCK						= "Monitor Fenster fixieren";

	RTM_MONITORLABEL	= "Wiederbelebungs Monitor"
	RTM_OPTIONHEADER	= "RezzTextMonitor "..GetAddOnMetadata("RezzTextMonitor", "Version")
	RTM_OK 				= "Ok"

	RTM_OMSCALE			= "Monitor Gr\195\182\195\159enverh\195\164ltnis"
	RTM_RTEXTONCHECK	= " AN - Monitor immer an"
	RTM_RTEXTOFFCHECK	= " AUS	- Monitor immer aus"
	RTM_RTEXTAUTOCHECK	= " AUTO - nur an, bei Bedarf."
	RTM_RTEXTNOBATTLE	= " Kein Monitor in Battlegrounds"
	RTM_RCHATTEXT		= " Chat text an/aus"
	RTM_BATTLETEXT		= " Keine Chatausgabe in Battlegrounds"
	RTM_AUTOCHAT		= " auto Chatwahl"
	RTM_SAYCHAT			= " Say"
	RTM_GRUPPECHAT		= " Gruppe"
	RTM_RAIDCHAT		= " Raid"


	RTM_LOCKMONITOR		= " Monitorfenster Fixieren"
	RTM_MONITORTIMER	= " Monitor Zeitgeber"
	RTM_REZZMACRO		= " Generiere Rezz-Makro (RTM)"
	RTM_REZZTEXTBOX		= " Hinweis Text mit Platzhalter  <name>"
	RTM_RESET			= "Reset Text"

    RTM_LOADED 			= "RezzTextMonitor "..GetAddOnMetadata("RezzTextMonitor", "Version") .." wurde geladen. /rtm \195\182ffnet das Men\195\188";
	RTM_REZZSPELLS		= 	{
								"Auferstehung",
								"Erl\195\182sung",
								"Wiedergeburt",
								"Geist der Ahnen",
							}
	RTM_REZZTEXT 		= "'<name>' wird wiederbelebt." 
	RTM_TOOLCORPSE		= "Leichnam von "
	RTM_UNKNOWN			= "Unbekanntes-Ziel"
	RTM_REZZED			= "Wiederbelebt!"
	RTM_PRIEST 			= "Priester";
	RTM_PALADIN			= "Paladin";
	RTM_SHAMAN			= "Schamane";
	RTM_DRUID			= "Druide";

	RTM_SPDTEXT			= "Es wurde eine alte Version von RezzText gefunden und deaktiviert. Soll die UI jetzt neu geladen werden ?"
	RTM_SPDJA 			= "Ja"
	RTM_SPDNEIN 		= "Baahhh Geh weg"

	RTM_FEIGNDEATH		= "Totstellen"

	RTMTooltips =	{ 
						["RezzBox"] = { "Wiederbelebungstext", "Dieser Text wird beim Wiederbeleben im Chat ausgegeben.", "<name> dient als Platzhalter f\195\188r den Zielnamen." },
						["ResetButton"] = { "Reset Text", "Hiermit wird der Hinweistext auf die", "Standarteinstellung zur\195\188ckgesetzt." },
						["ChatButton"] = { "Chatausgabe", "Aktiviert die Ausgabe des", "Hinweistextes im Chat." },
						["BattleButton"] = { "Keine Chatausgabe in Battlegrounds", "Verhindert die Ausgabe des", "Hinweistextes in Battlegrounds." },
						["ACButton"] = { "Automatische Chatausgabe", "Benutzt Chats in der Reihenfolge:", "Raid -> Gruppe -> Sagen." },
						["SCButton"] = { "Say Chatausgabe", "Der Hinweistext wird nur", "im Sagenchat ausgegeben." },
						["GCButton"] = { "Gruppen Chatausgabe", "Der Hinweistext wird nur", "im Gruppenchat ausgegeben." },
						["RCButton"] = { "Raid Chatausgabe", "Der Hinweistext wird nur", "im Raidchat ausgegeben." },
						["ScaleSlider"] = { "Monitor Gr\195\182\195\159enverh\195\164ltnis", "Hiermit kann der Wiederbelebungsmonitor", "verg\195\182\195\159ert oder verkleinert werden." },
						["RTextOnCheckButton"] = { "Monitor immer an", "Das Fenster vom Wiederbelebungsmonitor", "wird permanent angezeigt." },
						["RTextOffCheckButton"] = { "Monitor immer aus", "Das Fenster vom Wiederbelebungsmonitor", "wird nie angezeigt." },
						["RTextautoCheckButton"] = { "Monitor automatisch an oder aus", "Zeigt das Monitorfenster wenn ein Raidmitglied tot ist.", "Fenster wird nicht w\195\164rend des Kampfes angezeigt." },
						["RTextBattleCheckButton"] = { "Kein Monitor in Battlegrounds", "Verhindert die Anzeige des", "Monitorfensters in Battlegrounds." },
						["LockButton"] = { "Monitorfenster Fixieren", "Verhindert das verschieben des", "Monitorfensters." },
						["TimeButton"] = { "Monitor Zeitgeber", "Aktiviert Zeitz\195\164hler im Monitorfenster.", "" },
						["MacroButton"] = { "Generiere Rezz-Makro", "Erstellt ein Makro zum wiederbeleben, sobald", "ein totes Raidmitglied in Reichweite ist." },
						["OkButton"] = { "Ok", "Optionsfenster verlassen.", "" },
						["RUIButton"] = { "Reload UI", "Benutzerinterface neu geladen.", "(nur zum testen & Fehlersuche)" },
					};

end


